Bug 441341 - PDF printer rendering does not display correctly in Adobe Reader
PDF printer rendering does not display correctly in Adobe Reader
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gnome-print (Show other bugs)
11
All Linux
low Severity low
: ---
: ---
Assigned To: John (J5) Palmieri
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-04-07 13:14 EDT by Michael Wiktowy
Modified: 2013-03-13 00:51 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 06:34:24 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Test case of incorrect PDF rendering (Sudoku puzzle) (38.10 KB, application/pdf)
2008-04-07 13:14 EDT, Michael Wiktowy
no flags Details

  None (edit)
Description Michael Wiktowy 2008-04-07 13:14:30 EDT
Description of problem:
I attempted to output to PDF file, with the pseudo PDF Print device, some Sudoku
puzzles from the Gnome Sudoku app. I printed two puzzles per page and everything
seemed to display fine with Evince. However, when viewed on a Windows platform
using Adobe Reader 8 (one would presume to be the gold standard of PDF viewing)
the top puzzle displays fine but the bottom one of each page displays an empty grid.

Version-Release number of selected component (if applicable):
Adobe Reader 8
Rawhide LiveCD snapshot 20080404

How reproducible:
Always

Steps to Reproduce:
1. Open Sudoku in Gnome and print 10 puzzles with two to a page
2. Open in Evince
3. Open in Adobe Reader 8 on Windows
  
Actual results:
Open in Evince displays fine
Open in Adobe Reader on Windows only displays the top puzzle numbers and not the
bottom ones.


Expected results:
The PDF should display correctly regardless of platform/reader. That is the
selling point of the PDF format.

Additional info:
This issue may just be the Sudoku app but it might point to a deeper rendering
issue within Cairo and this is a nice small test case.
Strangely enough, it appears that the numbers for the bottom puzzle are there,
they may just be rendering in white on a white background. If I open a page of
the PDF with the new Inkscape on Windows it shows up fine. If I then re-save
that single page the seconds puzzle shows up fine in Adobe Reader. So whatever
Inkscape (which I believe also uses Cairo) does in Windows corrects the problem.
Comment 1 Michael Wiktowy 2008-04-07 13:14:30 EDT
Created attachment 301541 [details]
Test case of incorrect PDF rendering (Sudoku puzzle)
Comment 2 Behdad Esfahbod 2008-04-08 12:35:21 EDT
What cairo version?  Can you please report this upstream at bugs.freedesktop.org
against cairo?
Comment 3 Michael Wiktowy 2008-04-13 22:12:08 EDT
Bug was created upstream as requested:
http://bugzilla.gnome.org/show_bug.cgi?id=527954

I tried it with cairo 1.5.16 that was included with Rawhide Snapshot LiveCD
20080404. 
I also did an upgrade to cairo 1.6.4 and restarted X and the results were the same.
Comment 4 Bug Zapper 2008-05-14 05:06:14 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Adrian Johnson 2008-05-28 05:42:27 EDT
(In reply to comment #1)
> Created an attachment (id=301541) [edit]
> Test case of incorrect PDF rendering (Sudoku puzzle)
> 

This is not a cairo bug as the PDF was created by gnomeprint (select
File->Properties in either Evince or Acroread).



Comment 6 Michael Wiktowy 2008-05-28 13:55:46 EDT
If not cairo, what does gnome-print (the "Create a PDF document" option that is
given in the print dialog) use to render PDFs?
Comment 7 Behdad Esfahbod 2008-05-28 14:21:44 EDT
Nothing.  It does it itself.
Comment 8 John (J5) Palmieri 2008-05-29 10:56:13 EDT
That is a gnome-print issue.  I'm guessing the solution would be to get sudoko
guys to move to gtkprint since gnome-print is deprecated.  I would file this
upstream with them.
Comment 9 Michael Wiktowy 2008-05-29 14:21:52 EDT
OK ... there is a bug already filed against gnome-print upstream. I should be
able to switch the component over to Sudoku and suggest gtkprint.

Is it gtkprint that uses cairo as a backend to render to PDF? Or is it yet
another PDF generator?
Comment 10 John (J5) Palmieri 2008-05-30 11:13:03 EDT
I was actually taking a break from my normal duties to look at the sudoku code
yesterday.  gtkprint does in fact use cairo as the backend for pdf generation. 
Even better, sudoku is in python so fairly easy to retrofit.  What needs to
happen is the sudoku guys need to use Gtk.PrintOperation, split up their
callback to print each page (the gtkprint callback gets called for each page)
and switch their gtkprint rendering code to cairo.  The cairo bit should be dead
easy because I believe they display their sudoku board using cairo anyway.  If
not the gnome-print primitives map almost directly to cairo.
Comment 11 Michael Wiktowy 2008-05-31 16:56:06 EDT
Thanks John.

I added some commentary on the upstream bug and changed its component over to
gnome-games so hopefully there is more response than filing it against a defunct
system.

I am a little confused though. I thought that switching the backends for
rendering PDFs via the printing system would be best done at the printing system
level and not in every single app. Or is it the fact that the Gnome printing
system infrastructure got upgraded from gnome-print to gtkprint and many apps
are still pointing at the old gnome-print that is kept around for compatibility?
Comment 12 John (J5) Palmieri 2008-06-02 09:44:54 EDT
gnome-print was at best a hack since we had no real drawing backend to speak of.
 When we went about designing gtkprint we centred it around cairo which already
had an excellent ps and pdf output backend.  Since all applications are supposed
to move to using cairo and pango for drawing this all made sense since the same
code that draws the screen can be used to print.  There are still some issues
such as pagination that do have to be taken into account.     Since printing
itself is a complex operation it wasn't as easy as just replacing the
gnome-print API's.  We took the chance to design a fuller API but in the process
made it a bit harder to port existing applications due to the differences in
approach. Most maintainers will take the if it works then don't fix it approach
and since and since printing is decidedly unsexy it is going to take awhile for
all the apps to be ported.  All new apps should however find it much easier to
start with gtkprint from the get go.
Comment 13 Michael Wiktowy 2008-06-02 10:25:01 EDT
OK. Thank you for the clear explanation.

Are there plans for an estimated Gnome release version that these developers
should know about where gnome-print will be removed completely and gtkprint will
take over?

I just suspect that bugs like this will rot in limbo since gnome-print is
depreciated (so no one is interested in fixing bugs in it) yet apps are still
using it (so the bugs affect them).
Comment 14 John (J5) Palmieri 2008-06-02 11:28:02 EDT
It really should be done ASAP in all apps but since there are so many other
fires to fight most maintainers are going to put it low on the list.  If more
people file bugs like yours it may be fixed sooner than later.  

libgnome print has not been deprecated yet
(http://live.gnome.org/TwoPointTwentythree/Desktop) but is listed as an upcoming
deprecation.  I'm on the release team so I can recommend it.
Comment 15 Michael Wiktowy 2008-06-02 15:08:06 EDT
Hmmmm ... catch 22.

If I go on a targeted upstream bug-hunting safari (I think repoquery
--whatrequires libgnomeprint would get me on the right road), is there a simple
gnome-print -> gtkprint migration page that I could point the devs to?

All I could Google up was:
http://advogato.org/person/pbor/diary/59.html
which is just an example and not really a complete migration guide.

I would think that if such a guide existed, the activation energy for migrating
upstream projects would be reduced.

However, when all is said and done, I don't know if cairo will render the PDFs
any better for this app. However, I would guess that there is more chance of
getting things fixed in the shiny and new gtkprint/cairo than the old and crufty
gnome-print.
Comment 16 Bug Zapper 2009-06-09 20:04:08 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 17 Bug Zapper 2009-07-14 11:36:44 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 18 Michael Wiktowy 2009-07-22 23:15:46 EDT
This problem still exists in Fedora 11.
Comment 19 Bug Zapper 2010-04-27 07:59:02 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 20 Bug Zapper 2010-06-28 06:34:24 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.